package hash

import (
	"crypto/sha256"
	"encoding/hex"
	"fmt"

	pb "gitlab.com/danialmaki.dm/2_go_layout/pkg/autogenerated"
)

type simpleHash struct {
}

func (s *simpleHash) GetRecord(reqStruct *pb.SubmitRequest, nonce int64) (string, error) {
	return reqStruct.Src + reqStruct.Dest + fmt.Sprint(reqStruct.Amount) +
		fmt.Sprint(reqStruct.DateTime) + reqStruct.PrevHash + fmt.Sprint(nonce), nil
}

func (s *simpleHash) GetSha256(str string) (string, error) {
	hashedByte := sha256.Sum256([]byte(str))
	return hex.EncodeToString(hashedByte[:]), nil
}

func NewSimpleHash() Hash {
	return &simpleHash{}
}
